/* A REXX implementation of simple finger daemon */
/* It is not a complete rfc1288 implementation   */
/* It accepts a connection to port 79 and        */
/* sends an output of a user defined REXX script */

say "Finger daemon"

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

userscript = 'F.CMD'

/* search the fullpath of user script */
fullscriptpath = SysSearchPath('PATH', userscript )

/* make a nam for temporary file, use %TMP% if it exists */
tempfile = value('TMP',,'OS2ENVIRONMENT')||'\FINGER.TEMPORARY.FILE'

say 'Temporary file' tempfile
say 'fullscriptpath   file' fullscriptpath

crlf = '0d0a'x

defmsg = "I'm a simple finger daemon"||crlf
defmsg = defmsg||"Unfortunately a user did not supply me with a script"||crlf

if RxFuncQuery('SockLoadFuncs') \= 0 then do
    rc = RxFuncAdd('SockLoadFuncs','rxSock','SockLoadFuncs')
    if rc \= 0 then do
        say 'Cannot load rxsock.dll'
        call terminate0
    end
end
rc = SockLoadFuncs()

say 'Socket version' SockVersion()

rc = SockInit()
if rc \= 0 then do
    say 'Init error' rc
    call terminate1
end

socket = SockSocket("AF_INET","SOCK_STREAM","IPPROTO_TCP")
say 'Socket:' socket

server.family = "AF_INET"
server.port = 79
server.addr = INADDR_ANY

rc = SockBind(socket, "server.")
if rc \= 0 then  do
    say "Bind error" rc
    call terminate2
end

rc = SockListen(socket, 1)
if rc \= 0 then  do
    say "Listen error" rc
    call terminate2
end

if LENGTH(STREAM(fullscriptpath,'c','query exist')) = 0 then do
    /* user defined script file does not exists */
    internalmessage = 1
    say 'Using message:'
    say defmsg
end
else do
    internalmessage = 0
    say 'Using file:' fullscriptpath
end

say "Setting Ctrl-Break handler . . ."
SIGNAL ON HALT NAME terminate3 
say "Initialization done"

do while rc \= -1

    newsocket = SockAccept(socket)

    rc = SockGetPeerName(newsocket, "client.")
    rc = SockGetHostByAddr(client.addr, "host.")
    say "Request from" host.name "(" client.addr ")"
 
    /* receive any data from socket */
    rc = SockRecv(newsocket, "recvdata", 256 )
    /* strip cf/lf */
    str = left( recvdata, length(recvdata)-2)
    say 'Recv:'
    say '['||str||']'

    if internalmessage = 0 then do
        say "Sending file..."
        '@C:\OS2\CMD.EXE /Q /C ""'fullscriptpath'"" '||str||' >' tempfile
        do while LINES(tempfile) \= 0 
            rc = SockSend(newsocket, LINEIN(tempfile)||crlf)
        end
        if STREAM(tempfile,'c','close') = 'ERROR' then do
            call terminate3
        end
    end
    else do 
        say "Sending default message ..."
        rc = SockSend(newsocket, defmsg)
    end
    say "Done"

    rc = SockClose(newsocket) 
    say "Connection closed"

end


terminate3:
    say "Terminating ..."
    rc = STREAM(tempfile,'c','close') 
    if LENGTH(STREAM(tempfile,'c','query exist')) \= 0 then do
        say 'Erasing temporary file ...'
        '@erase ' tempfile
        say 'Done'
    end
    rc = SockClose(newsocket) 
terminate2:
    rc = SockClose(socket) 
terminate1:
    rc = SockDropFuncs()
terminate0:
    exit
    